SystemOrganization addCategory: #'Rizel-Core-Tests'!

TestCase subclass: #RzObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Core-Tests'!

!RzObjectTest commentStamp: '<historical>' prior: 0!
A RzObjectTest is a test class for testing the behavior of RzObject!

!RzObjectTest methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:00'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).

	mp3s add: (RSMP3File named:'MP3E' size:10).

	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:54'!
testEquality
	|profile rzProfile|
	
	profile := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	
	rzProfile := RzProfile merge: profile with: profile.
	
	self assert: (rzProfile newMethods size = 0).
	self assert: (rzProfile deletedMethods size = 0).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:02'!
testHasDifferent
	|obj obj2|
	obj := RzObject old: 4 new: 2.
	obj2 := RzObject old: 2 new:2.
	self assert: (obj hasDifferent:#printString).
	self assert: (obj2 hasDifferent: #printString) not.! !

!RzObjectTest methodsFor: 'testing' stamp: 'JPSA 1/30/2013 17:59'!
testHasSameArguments
	|A B rzProfile|
	A := RzProfilerSpy profile: [
		RSTextFile named:'TextA' size:10.
		] inClassCategory:'Rizel-Test-Scenario'.

	B := RzProfilerSpy profile: [
		RSTextFile named:'TextA' size:15.
		] inClassCategory:'Rizel-Test-Scenario'.
	rzProfile := RzProfile merge: A with: B.
	self assert: (((rzProfile classAt: 'RSFile') localMethodAt: 'size:') hasSameArguments not).
	"self assert: (rzProfile >>#'RSMember'>>#'name:') hasSameArguments."! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:07'!
testInitialize
	|robj|
	robj := RzObject old: 4 new: 5.
	
	self assert:( (robj property:#printString from:#old) = '4' ).
	self assert:( (robj property:#printString from:#new) = '5' ).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:20'!
testMerge1
	|A B rzProfile|
	Gofer new
		url:'http://ss3.gemstone.com/ss/Versionner';
		version:'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.1';
		load.
	A := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	Gofer new
		url:'http://ss3.gemstone.com/ss/Versionner';
		version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.2';
		load.
	B := RzProfilerSpy profile: [
		self buildPendrive.
		] inClassCategory:'Rizel-Test-Scenario'.
	rzProfile := RzProfile merge: A with: B.
	self assert: (rzProfile newMethods size = 1).
	self assert: ((rzProfile methods select: #hasDifferentByteCode) size = 2).! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 21:01'!
testNew
	|obj|
	obj := RzObject old: 4 new: 2.
	
	self assert: ((obj property:#printString from:#old) = '4').
	self assert: ((obj property:#printString from:#new) = '2').! !

!RzObjectTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:24'!
testProperties
	|robj robj2 robj3 robj4|
	robj := RzObject old: 4 new: 5.
	robj2 := RzObject old: nil new: 5.
	robj3 := RzObject old: 4 new: nil.
	robj4 := RzObject old: nil new: nil.
	
	self assert:( (robj property:#printString) = '5' ).
	self assert:( (robj2 property:#printString) = '5' ).
	self assert:( (robj3 property:#printString) = '4' ).
	self assert:( (robj4 property:#printString) = nil ).
	self assert:( (robj4 property:#printString ifAbsent:[true]) ).! !
